/*
  kernel_code.cu
*/
#include <stdio.h>

// Device code
__global__ void CUDAexp(double* b, double* c, int N) {
        int index = threadIdx.x+blockDim.x*blockIdx.x;
        if( index < N) c[index] = exp(b[index]);
}


extern "C" void  gexp_(double *a, double *d, int* N1)
{
        double *b,*c;
        int N=*N1;
        cudaError_t statusb,statusc,err;


        statusb=cudaHostGetDevicePointer((void **)&b, (void *) a, 0);
        statusc=cudaHostGetDevicePointer((void **)&c, (void *) d, 0);

        if (statusb != 0 || statusc !=0) {
                printf("Error when locating memory to arrays on device!\n");
                printf("%s\n",cudaGetErrorString(statusb));
                printf("%s\n",cudaGetErrorString(statusc));
        }

     // Cal the cuda kernel, just one block for this simple example.
      CUDAexp<<<1,N>>>(b,c, N);

      err=cudaGetLastError();
      if(err != 0) printf("Error in kernel execution\n");
 
     // This is very important to retrieve the correct values
      cudaThreadSynchronize();
}
